/*  $Id: resourcetype_string.h,v 1.14 2004/01/02 15:42:43 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

//! clanCore="Resources"
//! header=core.h

#ifndef header_resourcetype_string
#define header_resourcetype_string

#if _MSC_VER > 1000
#pragma once
#endif

#include "resourcedata.h"
#include <string>

//: Resource Data object for a 'string' resource type.
//- !group=Core/Resources!
//- !header=core.h!
class CL_ResourceData_String : public CL_ResourceData
{
//! Construction:
public:
	//: Resource Data String Constructor.
	CL_ResourceData_String(class CL_Resource &resource);

//! Attributes:
public:
	//: The string.
	std::string value;
};

#endif
